/*  
 * mycoagent.c
 *
 * This is an example agent that showcases the use of mycorrhiza.
 */

#include <time.h>
#include "../../src/myco-agent.c"

int main (int argc, char *argv []) {
    if (argc != 2) {
        printf ("usage: receive <message-size>\n");
        return 1;
    }


    char *agent_name = "DOMAIN1_MYAGENT2";
    int agent_message_queue_id;
    agent_message_queue_id = myco_agent_register(agent_name);

    char *resource_name = "RESOURCE";
    int resource_size = atoi (argv [1]);
    void *resource_pointer = myco_agent_register_resource(agent_message_queue_id, agent_name, resource_name, RESOURCE_TRANSACTIONAL, getpid(), resource_size);

    // Put some random numbers into RESOURCE
    int i;
    srand(time(NULL));
    for (i=0; i < resource_size/sizeof(int); i++) {
        ((int *)resource_pointer)[i] = rand();
    }

    // Sleep, so the showcase program can request RESOURCE
    printf("Wating for data to be requested.\n");
    sleep(30);

    // At the end of its runtime the agent unregisters with the agent.
    myco_agent_unregister(agent_name, agent_message_queue_id);

    return EXIT_SUCCESS;
}
