/* Copyright (C) 2016 Max Riechelmann <max.riechelmann@student.kit.edu>
   (Karlsruhe Institute of Technology)
   This library is free software; you can redistribute it and/or modify it
   under the terms of the GNU Lesser General Public License as published by the
   Free Software Foundation; either version 2.1 of the License, or (at your
   option) any later version.
   This library is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
   details.
   You should have received a copy of the GNU Lesser General Public License along
   with this library; if not, write to the Free Software Foundation, Inc., 51
   Franklin St, Fifth Floor, Boston, MA 02110, USA
*/

/**
 * SECTION: myco-daemon
 * @Short_description: daemon library
 * @Title: MycoDaemon
 *
 * MycoAgent implements the agent side of the Mycorrhiza distributed system.
 * It (un-)registers with the mycoagent and provides information about 
 * accessible data RESOURCES.
 */

#ifndef __MYCO_DAEMON_H
#define __MYCO_DAEMON_H
#include "myco-ipc.c"

typedef struct myco_agent_ myco_agent;
struct myco_agent_ {
    char name[AGENT_NAME_LENGTH];
    myco_agent *next;
    myco_agent *prev;
};

typedef struct myco_resource_ myco_resource;
struct myco_resource_ {
    char name[RESOURCE_NAME_LENGTH];
    char agent[AGENT_NAME_LENGTH];
    myco_resource *next;
    myco_resource *prev;
};


/**
 * myco_daemon_start:
 * @myco_daemon_port: The port of the daemon
 *
 * Starts the daemon process on localhost.
 *
 * Returns: 0 on success, -1 on error 
 */
int myco_daemon_start ();

#endif //__MYCO_DAEMON_H
